searchNodes=[{"doc":"Tablex implements Decision Table. It's goal is to make domain rules easy to maintain.","ref":"Tablex.html","title":"Tablex","type":"module"},{"doc":"See Tablex.Decider.decide/2 .","ref":"Tablex.html#decide/2","title":"Tablex.decide/2","type":"function"},{"doc":"See Tablex.Decider.decide/3 .","ref":"Tablex.html#decide/3","title":"Tablex.decide/3","type":"function"},{"doc":"","ref":"Tablex.html#new/2","title":"Tablex.new/2","type":"function"},{"doc":"","ref":"Tablex.html#sigil_RULES/2","title":"Tablex.sigil_RULES/2","type":"function"},{"doc":"This module is responsible for generating Elixir code from a table.","ref":"Tablex.CodeGenerate.html","title":"Tablex.CodeGenerate","type":"module"},{"doc":"Transform a table into Elixir code. Examples iex&gt; table = &quot;&quot;&quot; ...&gt; F CreditScore EmploymentStatus Debt-to-Income-Ratio || Action ...&gt; 1 700 employed &lt;0.43 || Approved ...&gt; 2 700 unemployed - || &quot;Further Review&quot; ...&gt; 3 &lt;=700 - - || Denied ...&gt; &quot;&quot;&quot; ...&gt; ...&gt; code = generate ( table ) ...&gt; is_binary ( code ) true The code generated in the above example is: case { credit_score , employment_status , debt_to_income_ratio } do { 700 , &quot;employed&quot; , debt_to_income_ratio } when is_number ( debt_to_income_ratio ) and debt_to_income_ratio &lt; 0.43 -&gt; %{ action : &quot;Approved&quot; } { 700 , &quot;unemployed&quot; , _ } -&gt; %{ action : &quot;Further Review&quot; } { credit_score , _ , _ } when is_number ( credit_score ) and credit_score &lt;= 700 -&gt; %{ action : &quot;Denied&quot; } end","ref":"Tablex.CodeGenerate.html#generate/1","title":"Tablex.CodeGenerate.generate/1","type":"function"},{"doc":"Decision engine module responsible for applying a set of rules to input data and returning the output according to the hit policy.","ref":"Tablex.Decider.html","title":"Tablex.Decider","type":"module"},{"doc":"Run the decision process on the given table, arguments, and options. Examples iex&gt; decide ( table , args ) output","ref":"Tablex.Decider.html#decide/3","title":"Tablex.Decider.decide/3","type":"function"},{"doc":"","ref":"Tablex.Decider.html#match_expect?/2","title":"Tablex.Decider.match_expect?/2","type":"function"},{"doc":"","ref":"Tablex.Decider.html#match_rule?/2","title":"Tablex.Decider.match_rule?/2","type":"function"},{"doc":"","ref":"Tablex.Decider.html#t:options/0","title":"Tablex.Decider.options/0","type":"type"},{"doc":"Parser is responsible for parsing the table from text to a Tablex.Table struct. Hit Policies Currently the following hit policies are supported: &quot;F&quot; for :first_hit &quot;C&quot; for :collect &quot;M&quot; for :merge &quot;R&quot; for :reverse_merge","ref":"Tablex.Parser.html","title":"Tablex.Parser","type":"module"},{"doc":"Parse a string into a table struct. Returns %Tablex.Table{...} if succeeds, other wise {:error, {:invalid, reason, rest}}","ref":"Tablex.Parser.html#parse/2","title":"Tablex.Parser.parse/2","type":"function"},{"doc":"Raising version of parse/2 .","ref":"Tablex.Parser.html#parse!/2","title":"Tablex.Parser.parse!/2","type":"function"},{"doc":"Parses the given binary as table. Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the table (start position) as {line, offset_to_start_of_line} . To column where the error occurred can be inferred from byte_offset - offset_to_start_of_line . Options :byte_offset - the byte offset for the whole binary, defaults to 0 :line - the line and the byte offset into that line, defaults to {1, byte_offset} :context - the initial context value. It will be converted to a map","ref":"Tablex.Parser.html#table/2","title":"Tablex.Parser.table/2","type":"function"},{"doc":"","ref":"Tablex.Parser.html#to_policy/1","title":"Tablex.Parser.to_policy/1","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html","title":"Tablex.Parser.Expression","type":"module"},{"doc":"","ref":"Tablex.Parser.Expression.html#any/0","title":"Tablex.Parser.Expression.any/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#bool/0","title":"Tablex.Parser.Expression.bool/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#comparation/0","title":"Tablex.Parser.Expression.comparation/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#expression/0","title":"Tablex.Parser.Expression.expression/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#false_exp/0","title":"Tablex.Parser.Expression.false_exp/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#float/0","title":"Tablex.Parser.Expression.float/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#implied_string/0","title":"Tablex.Parser.Expression.implied_string/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#int/0","title":"Tablex.Parser.Expression.int/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#list/0","title":"Tablex.Parser.Expression.list/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#null/0","title":"Tablex.Parser.Expression.null/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#numeric/0","title":"Tablex.Parser.Expression.numeric/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#range/0","title":"Tablex.Parser.Expression.range/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#trans_range/1","title":"Tablex.Parser.Expression.trans_range/1","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#true_exp/0","title":"Tablex.Parser.Expression.true_exp/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Expression.html#underscore_int/0","title":"Tablex.Parser.Expression.underscore_int/0","type":"function"},{"doc":"This module parses quoted strings.","ref":"Tablex.Parser.Quoted.html","title":"Tablex.Parser.Quoted","type":"module"},{"doc":"Parse a quoted string.","ref":"Tablex.Parser.Quoted.html#quoted_string/0","title":"Tablex.Parser.Quoted.quoted_string/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Rule.html","title":"Tablex.Parser.Rule","type":"module"},{"doc":"","ref":"Tablex.Parser.Rule.html#rule/0","title":"Tablex.Parser.Rule.rule/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Rule.html#rules/1","title":"Tablex.Parser.Rule.rules/1","type":"function"},{"doc":"","ref":"Tablex.Parser.Rule.html#seperator/0","title":"Tablex.Parser.Rule.seperator/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Space.html","title":"Tablex.Parser.Space","type":"module"},{"doc":"","ref":"Tablex.Parser.Space.html#eow/0","title":"Tablex.Parser.Space.eow/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Space.html#newline/1","title":"Tablex.Parser.Space.newline/1","type":"function"},{"doc":"","ref":"Tablex.Parser.Space.html#optional_space/1","title":"Tablex.Parser.Space.optional_space/1","type":"function"},{"doc":"","ref":"Tablex.Parser.Space.html#space/1","title":"Tablex.Parser.Space.space/1","type":"function"},{"doc":"","ref":"Tablex.Parser.Variable.html","title":"Tablex.Parser.Variable","type":"module"},{"doc":"","ref":"Tablex.Parser.Variable.html#name/0","title":"Tablex.Parser.Variable.name/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Variable.html#type/0","title":"Tablex.Parser.Variable.type/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Variable.html#type_enum/0","title":"Tablex.Parser.Variable.type_enum/0","type":"function"},{"doc":"","ref":"Tablex.Parser.Variable.html#variable/0","title":"Tablex.Parser.Variable.variable/0","type":"function"},{"doc":"","ref":"Tablex.Table.html","title":"Tablex.Table","type":"module"},{"doc":"","ref":"Tablex.Table.html#new/1","title":"Tablex.Table.new/1","type":"function"},{"doc":"","ref":"Tablex.Table.html#t:hit_policy/0","title":"Tablex.Table.hit_policy/0","type":"type"},{"doc":"","ref":"Tablex.Table.html#t:input/0","title":"Tablex.Table.input/0","type":"type"},{"doc":"","ref":"Tablex.Table.html#t:output/0","title":"Tablex.Table.output/0","type":"type"},{"doc":"","ref":"Tablex.Table.html#t:rule/0","title":"Tablex.Table.rule/0","type":"type"},{"doc":"","ref":"Tablex.Table.html#t:t/0","title":"Tablex.Table.t/0","type":"type"},{"doc":"","ref":"Tablex.Table.html#t:var_name/0","title":"Tablex.Table.var_name/0","type":"type"},{"doc":"","ref":"Tablex.Table.html#t:var_type/0","title":"Tablex.Table.var_type/0","type":"type"},{"doc":"Tablex is an implementation of the Decision Table in Elixir. Its goal is to make maitaining domain rules easy.","ref":"readme.html","title":"Tablex - Decision Tables in Elixir Code","type":"extras"},{"doc":"Let's assume we decide what to do everyday based on day of week and the weather, as the following table indicates: Day Weather Activity Monday,Tuesday,Wednesday,Thursday rainy read Monday,Tuesday,Wednesday,Thursday - read,walk Friday sunny soccer Friday - swim Saturday - watch movie, games Sunday - null We can use a similar tabular form of the code in an Elixir program: ...&gt; plans = Tablex . new ( &quot;&quot;&quot; ...&gt; F Day (string) Weather (string) || Activity ...&gt; 1 Monday,Tuesday,Wednesday,Thursday rainy || read ...&gt; 2 Monday,Tuesday,Wednesday,Thursday - || read,walk ...&gt; 3 Friday sunny || soccer ...&gt; 4 Friday - || swim ...&gt; 5 Saturday - || &quot;watch movie&quot;,games ...&gt; 6 Sunday - || null ...&gt; &quot;&quot;&quot; ) ...&gt; ...&gt; Tablex . decide ( plans , day : &quot;Monday&quot; ) %{ activity : [ &quot;read&quot; , &quot;walk&quot; ] } ...&gt; ...&gt; Tablex . decide ( plans , day : &quot;Friday&quot; , weather : &quot;sunny&quot; ) %{ activity : &quot;soccer&quot; } ...&gt; ...&gt; Tablex . decide ( plans , day : &quot;Sunday&quot; ) %{ activity : nil } The above code demonstrates how we can determine what to do based on a set of rules which are represented in a decision table on day and weather condition. Inside the table, we defined the decision logic with: An indicator of hit policy, F in this case meaning the first rule matched will be applied. See Hit Policies section for more information. Two input stubs, day and weather which are both strings. See Input Stubs section An output stub, activity in this case. See Output Stubs section Six rules which take inputs and determine the acitivity output. See Rules section A friendly expression in each cell of the rules. See Expression section","ref":"readme.html#quick-demo","title":"Tablex - Decision Tables in Elixir Code - Quick demo","type":"extras"},{"doc":"Inputs can be defined with a set of name (type[, description]) pairs. For example: Age (integer) defines an input field whose name is &quot;age&quot; and type is integer. DOB (date, date of birth) defines a date input field with a description label. Name Names can contain spaces in them if they are quoted. The following names are valid: year_month_day yearMonthDay &quot;year month day&quot; They will all be converted to year_month_day . Type Currently the following types are supported: integer float number string bool When types are specified, the input value shall be of the same type as specified.","ref":"readme.html#input-stubs","title":"Tablex - Decision Tables in Elixir Code - Input Stubs","type":"extras"},{"doc":"Output stubs are defined as name (type[, description]) where name can be a string which will be converted to an underscored atom; type can be either of the supported types (the same as inputs, see above section); description is optional and is currently ignored.","ref":"readme.html#output-stubs","title":"Tablex - Decision Tables in Elixir Code - Output Stubs","type":"extras"},{"doc":"After output stub definitions, each of the following rows defines a rule entry, with the format: rule_number input_exp_1 input_exp_2 ... input_exp_m || output_exp_1 output_exp_2 ... output_exp_n Rule number is primarily used for ordering. The rule with the lowest rule number has the highest priority. Input expressions and output expressions are separated by &quot;||&quot;.","ref":"readme.html#rules","title":"Tablex - Decision Tables in Elixir Code - Rules","type":"extras"},{"doc":"Currently only these types are supported: literal numeric value: integer and float (without scientific notation) literal quoted string in &quot; boolean comparation: &gt; , &gt;= , &lt; , &lt;= range, e.g. 5..10 nil (&quot;null&quot;) list of numeric, string, range, bool, nil or comparation; can be mixed any (&quot;-&quot;) The following types of expressions are planned: date time datetime function","ref":"readme.html#expression","title":"Tablex - Decision Tables in Elixir Code - Expression","type":"extras"},{"doc":"There are several hit policies to indicate how matched rules are applied. F (First matched) - the first matched rule will be applied. C (Collect) - all matched rules will be collected into result list. M (Merge) - all matched rules will be reduced (merged) into a single return entry. R (Reverse Merge) - all matched rules will be reduced (merged) into a single return entry, with a reversed order. Examples: First Hit iex&gt; table = Tablex . new ( &quot;&quot;&quot; ...&gt; F Age (integer) || f (float) ...&gt; 1 &gt; 60 || 3.0 ...&gt; 2 50..60 || 2.5 ...&gt; 3 31..49 || 2.0 ...&gt; 4 15..18,20..30 || 1.0 ...&gt; 5 - || 0 ...&gt; &quot;&quot;&quot; ...&gt; ) ...&gt; ...&gt; Tablex . decide ( table , age : 30 ) %{ f : 1.0 } iex&gt; Tablex . decide ( table , age : 55 ) %{ f : 2.5 } iex&gt; Tablex . decide ( table , age : 22 ) %{ f : 1.0 } iex&gt; Tablex . decide ( table , age : 17 ) %{ f : 1.0 } iex&gt; Tablex . decide ( table , age : 1 ) %{ f : 0 } iex&gt; table = Tablex . new ( &quot;&quot;&quot; ...&gt; F Age (integer) &quot;Years of Service&quot; || Holidays (integer) ...&gt; 1 &gt;=60 - || 3 ...&gt; 2 45..59 &lt;30 || 2 ...&gt; 3 - &gt;=30 || 22 ...&gt; 4 &lt;18 - || 5 ...&gt; 5 - - || 10 ...&gt; &quot;&quot;&quot; ...&gt; ) ...&gt; ...&gt; Tablex . decide ( table , age : 46 , years_of_service : 30 ) %{ holidays : 22 } ...&gt; iex&gt; Tablex . decide ( table , age : 17 , years_of_service : 5 ) %{ holidays : 5 } ...&gt; iex&gt; Tablex . decide ( table , age : 22 ) %{ holidays : 10 } Collect Here's an example of collect hit policy: iex&gt; table = Tablex . new ( &quot;&quot;&quot; ...&gt; C OrderAmount Membership || Discount ...&gt; 1 &gt;=100 false || &quot;Free cupcake&quot; ...&gt; 2 &gt;=100 true || &quot;Free icecream&quot; ...&gt; 3 - true || &quot;20% OFF&quot; ...&gt; &quot;&quot;&quot; ...&gt; ) ...&gt; iex&gt; Tablex . decide ( table , order_amount : 500 , membership : false ) [ %{ discount : &quot;Free cupcake&quot; } ] ...&gt; iex&gt; Tablex . decide ( table , order_amount : 500 , membership : true ) [ %{ discount : &quot;Free icecream&quot; } , %{ discount : &quot;20% OFF&quot; } ] ...&gt; iex&gt; Tablex . decide ( table , order_amount : 80 ) [ ] Collect policy can work without any input: iex&gt; table = Tablex . new ( &quot;&quot;&quot; ...&gt; C || Country FeatureVersion ...&gt; 1 || &quot;New Zealand&quot; 3 ...&gt; 2 || &quot;Japan&quot; 2 ...&gt; 3 || &quot;Brazil&quot; 2 ...&gt; &quot;&quot;&quot; ...&gt; ) ...&gt; iex&gt; Tablex . decide ( table , [ ] ) [ %{ country : &quot;New Zealand&quot; , feature_version : 3 } , %{ country : &quot;Japan&quot; , feature_version : 2 } , %{ country : &quot;Brazil&quot; , feature_version : 2 } ] Merge Here's an example of merge hit policy: iex&gt; table = Tablex . new ( &quot;&quot;&quot; ...&gt; M Continent Country Province || Feature1 Feature2 ...&gt; 1 Asia Thailand - || true true ...&gt; 2 America Canada BC,ON || - true ...&gt; 3 America Canada - || true false ...&gt; 4 America US - || false false ...&gt; 5 Europe France - || true - ...&gt; 6 Europe - - || false true ...&gt; &quot;&quot;&quot; ...&gt; ) ...&gt; iex&gt; Tablex . decide ( table , continent : &quot;Asia&quot; , country : &quot;Thailand&quot; , province : &quot;ACR&quot; ) %{ feature1 : true , feature2 : true } ...&gt; iex&gt; Tablex . decide ( table , continent : &quot;America&quot; , country : &quot;Canada&quot; , province : &quot;BC&quot; ) %{ feature1 : true , feature2 : true } ...&gt; iex&gt; Tablex . decide ( table , continent : &quot;America&quot; , country : &quot;Canada&quot; , province : &quot;QC&quot; ) %{ feature1 : true , feature2 : false } ...&gt; iex&gt; Tablex . decide ( table , continent : &quot;Europe&quot; , country : &quot;France&quot; ) %{ feature1 : true , feature2 : true } The rules are applied until all the output fields are determined. Reverse Merge The reverse_merge works the same as merge but the rule ordering is reversed: iex&gt; table = Tablex . new ( &quot;&quot;&quot; ...&gt; R Continent Country Province || Feature1 Feature2 ...&gt; 1 Europe - - || false true ...&gt; 2 Europe France - || true - ...&gt; 3 America US - || false false ...&gt; 4 America Canada - || true false ...&gt; 5 America Canada BC,ON || - true ...&gt; 6 Asia Thailand - || true true ...&gt; &quot;&quot;&quot; ...&gt; ) ...&gt; iex&gt; Tablex . decide ( table , continent : &quot;Asia&quot; , country : &quot;Thailand&quot; , province : &quot;ACR&quot; ) %{ feature1 : true , feature2 : true } ...&gt; iex&gt; Tablex . decide ( table , continent : &quot;America&quot; , country : &quot;Canada&quot; , province : &quot;BC&quot; ) %{ feature1 : true , feature2 : true } ...&gt; iex&gt; Tablex . decide ( table , continent : &quot;America&quot; , country : &quot;Canada&quot; , province : &quot;QC&quot; ) ...&gt; %{ feature1 : true , feature2 : false } ...&gt; iex&gt; Tablex . decide ( table , continent : &quot;Europe&quot; , country : &quot;France&quot; ) %{ feature1 : true , feature2 : true }","ref":"readme.html#hit-policies","title":"Tablex - Decision Tables in Elixir Code - Hit policies","type":"extras"},{"doc":"It is feasible to generate Elixir code from a table with Tablex.CodeGenerate.generate/1 , as: table = &quot;&quot;&quot; F CreditScore EmploymentStatus Debt-to-Income-Ratio || Action 1 700 employed &lt;0.43 || Approved 2 700 unemployed - || &quot;Further Review&quot; 3 &lt;=700 - - || Denied &quot;&quot;&quot; Tablex.CodeGenerate . generate ( table ) The code generated in the above example is: case { credit_score , employment_status , debt_to_income_ratio } do { 700 , &quot;employed&quot; , debt_to_income_ratio } when is_number ( debt_to_income_ratio ) and debt_to_income_ratio &lt; 0.43 -&gt; %{ action : &quot;Approved&quot; } { 700 , &quot;unemployed&quot; , _ } -&gt; %{ action : &quot;Further Review&quot; } { credit_score , _ , _ } when is_number ( credit_score ) and credit_score &lt;= 700 -&gt; %{ action : &quot;Denied&quot; } end","ref":"readme.html#generate-elixir-code","title":"Tablex - Decision Tables in Elixir Code - Generate Elixir Code","type":"extras"},{"doc":"The package can be installed by adding tablex to your list of dependencies in mix.exs : def deps do [ { :tablex , &quot;~&gt; 0.1.0&quot; } ] end The docs can be found at https://hexdocs.pm/tablex .","ref":"readme.html#installation","title":"Tablex - Decision Tables in Elixir Code - Installation","type":"extras"},{"doc":"Tablex is heavily inspired by DMN and its FEEL expression language. Tablex is built on top of the awesome nimble_parsec library.","ref":"readme.html#credits","title":"Tablex - Decision Tables in Elixir Code - Credits","type":"extras"},{"doc":"Tablex is open sourced under MIT license .","ref":"readme.html#license","title":"Tablex - Decision Tables in Elixir Code - License","type":"extras"}]